#ifndef EVENTFULNESS_H
#define EVENTFULNESS_H

#include <SFML/Window.hpp>
#include <SFGUI/SFGUI.hpp>
#include <SFML/System.hpp>
#include <SFML/Graphics.hpp>
#include <string>

class NotificationBar;
class CreateBar;
class WorldWindow;
class MashWindow;
class Render;
class World;
class RogueWindow;
class Object;
class Stat;

class BarButton;

class Eventfulness
{
public:
	void OnCreateBarButtonClick(BarButton*);
	void OnCreateBarButtonRightClick(BarButton*);
	
	void SetWorld(World*);
	void SetNotificationBar(NotificationBar*);
	void SetCreateBar(CreateBar*);
	void SetWorldWindow(WorldWindow*);
	void SetMashWindow(MashWindow*);
	void SetRogueWindow(RogueWindow*);
	void SetRender(Render*);
	void SetStat(Stat*);
	void BringToFront(sfg::Window::Ptr);
	
	void KeyPressed(sf::Event::KeyEvent);
	void NewMessage(std::string,std::string);
	
	void NewButtonPoked(BarButton*);
	void CreateNewObject(Object*,std::string);
	
	void ItsGameOver(bool);

private:
	World* m_World;
	NotificationBar* m_NotificationBar;
	CreateBar* m_CreateBar;
	WorldWindow* m_WorldWindow;
	MashWindow* m_MashWindow;
	RogueWindow* m_RogueWindow;
	Render* m_Render;
	Stat* m_Stat;

};

#endif