#include "MashWindow.h"
#include "Glob.h"
#include <string>

extern Glob* glob;

sfg::Window::Ptr MashWindow::GetPointer()
{
	return m_Window;
}

bool MashWindow::Init()
{
	m_Longdata = "";
	
	m_Window = sfg::Window::Create(sf::Style::Titlebar | sf::Style::Resize );
 	m_Window->SetTitle(" ");
	m_Window->SetPosition( sf::Vector2f(64+320,240));
	m_Window->SetClass( "mashwindow" );
	
	sfg::Box::Ptr m_scrolled_window_box = sfg::Box::Create( sfg::Box::VERTICAL );
	
	sfg::ScrolledWindow::Ptr scrolledwindow = sfg::ScrolledWindow::Create();
	scrolledwindow->SetScrollbarPolicy( sfg::ScrolledWindow::HORIZONTAL_ALWAYS | sfg::ScrolledWindow::VERTICAL_AUTOMATIC );

	scrolledwindow->AddWithViewport( m_scrolled_window_box );

	scrolledwindow->SetRequisition( sf::Vector2f( 512,256 ) );

	// Create a viewport.
	m_Viewport = sfg::Viewport::Create();

	// Always remember to set the minimum size of a Viewport.
	m_Viewport->SetRequisition( sf::Vector2f( 510, 254 ) );

	// Set the vertical adjustment values of the Viewport.
	m_Viewport->GetVerticalAdjustment()->SetLower( 0.f );
	m_Viewport->GetVerticalAdjustment()->SetUpper( 100000000.f );

	// Create a box for our Viewport. Viewports are bins
	// as well and can only contain 1 child widget.
	sfg::Box::Ptr viewport_box = sfg::Box::Create( sfg::Box::VERTICAL );
	m_Label = sfg::Label::Create(m_Longdata);
	m_Label->SetClass("mashwindow");
	m_Label->SetRequisition(sf::Vector2f(512,256));
	m_Label->SetLineWrap(true);
	viewport_box->Pack( m_Label );

	// Add the Viewport box to the viewport.
	m_Viewport->Add( viewport_box );
	
	m_Window->Add(m_Viewport);
	
	SetActive(true);
	
	return true;
}

void MashWindow::AddText()
{
	while (m_Longdata.size() > 1024)
	{
		m_Longdata.erase (m_Longdata.begin());
	}
	
	m_Longdata += m_MashGen.Get( 3 + rand() % 5 );
	m_Label->SetText(m_Longdata);
	
	m_Viewport->GetVerticalAdjustment()->SetValue( m_Label->GetRequisition().y - 256 );
}

void MashWindow::SetActive(bool act)
{
	if (act && !m_Active)
	{
		m_Window->Show(true);
		glob->event->BringToFront(m_Window);
		m_Active = true;
	}
	else if (!act && m_Active)
	{
		m_Window->Show(false);
		m_Active = false;
	}
}