#include "WorldWindow.h"
#include "World.h"
#include "Glob.h"

extern Glob* glob;

sfg::Window::Ptr WorldWindow::GetPointer()
{
	return m_Window;
}

bool WorldWindow::Init(World* world)
{
	m_World = world;
	
	m_Window = sfg::Window::Create(3);
 	m_Window->SetTitle(" ");
	m_Window->SetPosition( sf::Vector2f(64+40,40));
	m_Window->SetClass( "worldmap" );
		
	sf::Image worldMapSource;
	m_Image = sfg::Image::Create();
	
	if (worldMapSource.loadFromFile("worldmap.png"))
	{
		m_Image->SetImage(worldMapSource);
	}
	
	//m_Label1 = sfg::Label::Create("op99");
	//m_Label2 = sfg::Label::Create("?");
	
	m_Fixed = sfg::Fixed::Create();
	m_Fixed->Put (m_Image,  sf::Vector2f(0,0));
	//m_Fixed->Put( m_Label1, sf::Vector2f( 200.f, 50.f ) );
	//m_Fixed->Put( m_Label2, sf::Vector2f( 50.f, 200.f ) );
	
	m_Window->Add(m_Fixed);
	
	return true;
}

void WorldWindow::Update( std::list<Object*> objects)
{
	for (std::list<sfg::Label::Ptr>::iterator lab = m_Labels.begin(); lab!=m_Labels.end(); ++lab)
	{
		m_Fixed->Remove(*lab);
	}
	m_Labels.clear();

	//Draw things
	for (std::list<Object*>::iterator obj = objects.begin(); obj!=objects.end(); ++obj)
	{
		sfg::Label::Ptr label = sfg::Label::Create( (*obj)->m_Name );
		

		if 			( (*obj)->m_VisibleToPlayer > 14.0/16.0 )	label->SetClass( "f" );
		else if 	( (*obj)->m_VisibleToPlayer > 13.0/16.0 )	label->SetClass( "e" );
		else if 	( (*obj)->m_VisibleToPlayer > 12.0/16.0 )	label->SetClass( "d" );
		else if 	( (*obj)->m_VisibleToPlayer > 11.0/16.0 )	label->SetClass( "c" );
		else if 	( (*obj)->m_VisibleToPlayer > 10.0/16.0 )	label->SetClass( "b" );
		else if 	( (*obj)->m_VisibleToPlayer >  9.0/16.0 )	label->SetClass( "a" );
		else if 	( (*obj)->m_VisibleToPlayer >  8.0/16.0 )	label->SetClass( "nine" );
		else if 	( (*obj)->m_VisibleToPlayer >  7.0/16.0 )	label->SetClass( "eight" );
		else if 	( (*obj)->m_VisibleToPlayer >  6.0/16.0 )	label->SetClass( "seven" );
		else if 	( (*obj)->m_VisibleToPlayer >  5.0/16.0 )	label->SetClass( "six" );
		else if 	( (*obj)->m_VisibleToPlayer >  4.0/16.0 )	label->SetClass( "five" );
		else if 	( (*obj)->m_VisibleToPlayer >  3.0/16.0 )	label->SetClass( "four" );
		else if 	( (*obj)->m_VisibleToPlayer >  2.0/16.0 )	label->SetClass( "three" );
		else if 	( (*obj)->m_VisibleToPlayer >  1.0/16.0 )	label->SetClass( "two" );
		else if 	( (*obj)->m_VisibleToPlayer >  0.0/16.0 )	label->SetClass( "one" );
		else 													label->SetClass( "zero" );
		
		m_Fixed->Put (label, (*obj)->m_Position);
		m_Labels.push_back(label);
	}
	
}